; 

    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc

  ; ------------------------------------------
  ; proof that prototype duplication of an API
  ; from an IMPORT library does not increase
  ; the executable image size.
  ; ------------------------------------------
  REPEAT 1024
    wsprintfA PROTO C :DWORD,:VARARG
    wsprintf equ <wsprintfA>
  ENDM

  ; ----------------------------------------------------
  ; proof that prototype duplication of a static library
  ; does not increase the executable image.
  ; ----------------------------------------------------
  REPEAT 1024
    write_disk_file PROTO :DWORD,:DWORD,:DWORD
  ENDM

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\masm32.lib

    .code

start:
 
; 

    invoke ExitProcess,0

; 

end start

; ====================================

    Alternative prototype for wsprintfA
    -----------------------------------

    prntf TYPEDEF PROTO C :DWORD,:VARARG
    pfp TYPEDEF PTR prntf
    wsprintfA equ <(TYPE pfp) PTR prntf>
    wsprintf equ <wsprintfA>

; ====================================

With WINDOWS.INC included

 Imp Addr Hint Import Name from kernel32.dll - Not Bound
 -------- ---- ---------------------------------------------------------------
 00002000   80 ExitProcess

IAT Entry

 00000000: 00002038 00000000 

Disassembly

00401000                    start:
00401000 6A00                   push    0
00401002 E801000000             call    fn_00401008
00401007 CC                     int     3
00401008                    fn_00401008:
00401008 FF2500204000           jmp     dword ptr [ExitProcess]

; ====================================

With WINDOWS.INC commented out

 Imp Addr Hint Import Name from user32.dll - Not Bound
 -------- ---- ---------------------------------------------------------------
 00002008  262 wsprintfA

 Imp Addr Hint Import Name from kernel32.dll - Not Bound
 -------- ---- ---------------------------------------------------------------
 00002000   80 ExitProcess

IAT Entry

 00000000: 00002074 00000000 - 0000205C 00000000 

Disassembly

00401000                    start:
00401000 6A00                   push    0
00401002 E807000000             call    fn_0040100E
00401007 CC                     int     3
00401008 FF2508204000           jmp     dword ptr [wsprintfA]
0040100E                    fn_0040100E:
0040100E FF2500204000           jmp     dword ptr [ExitProcess]

; ====================================